-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local function onInit()
    electrics.values['4ws'] = 0
end

local function updateGFX(dt)
    if not electrics.values['steering_input'] then return end
    local steer = electrics.values['steering_input']
    local absSteer = math.abs(steer)
    local speed = electrics.values.wheelspeed

    local rws = ((speed * -0.0285714) + 1) * absSteer
    if rws < 0 then
        rws = 0
    end
    
    rws = rws * fsign(steer) --Use the sign of the steering input to know the sign of rws output

    electrics.values['4ws'] = rws
end

-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M