local M = {}

local chimenode = 350
local chime = nil
local hasStarted = nil

local time = false
local timer = 0

local function updateGFX(dt)

	if electrics.values.ignitionLevel == 2 and electrics.values.engineRunning == 1 then
	else
		hasStarted = false
		obj:stopSFX(chime)
	end

    if electrics.values.ignitionLevel == 2 and hasStarted == false then
		if chimenode ~= nil then
			obj:playSFX(chime)
			obj:setVolume(chime, 0.25)
			time = true
		end
		hasStarted = true
    end

	if time then
		timer = timer + dt
		if timer >= 5 then
			obj:stopSFX(chime)
			timer = 0
			time = false
		end
	end

end

local function init()
	
	for v, node in pairs (v.data.nodes) do	--for finding out the node ID
		if node.name == "int3" then	
			chimenode = v
		end
	end
	
	if chimenode ~= nil then
	    chime = obj:createSFXSource("art/sound/chimes/ETC1.mp3", 'AudioDefaultLoop3D', '', chimenode, 0)
	    obj:stopSFX(chime)
	    obj:setVolume(chime, 0.25)
	end

	if electrics.values.ignitionLevel == 2 and electrics.values.engineRunning == 1 then
		hasStarted = true
	else
		hasStarted = false
	end

end

local function onReset()
	if chimenode ~= nil then
		obj:stopSFX(chime)
		obj:setVolume(chime, 0.25)
	end

	if electrics.values.ignitionLevel == 2 and electrics.values.engineRunning == 1 then
		hasStarted = true
	else
		hasStarted = false
	end
end

M.onInit = init
M.updateGFX = updateGFX
M.onReset    = onReset

return M