
local M = {}

local abs = math.abs

local dynamicDiff = nil
local mainOutput = nil
local minMainOutput = nil
local minSubOutput = nil
local maxrpmDifference = nil
local stepping = nil

local function updateGFX(dt)

	if mainOutput == 1 then
		if abs(dynamicDiff.outputAV1 - dynamicDiff.outputAV2) * 9.549296596425384 >= maxrpmDifference and dynamicDiff.diffTorqueSplitA ~= minMainOutput then
			dynamicDiff.diffTorqueSplitA = dynamicDiff.diffTorqueSplitA - stepping
			dynamicDiff.diffTorqueSplitB = dynamicDiff.diffTorqueSplitB + stepping
		elseif dynamicDiff.diffTorqueSplitA ~= 1 - minSubOutput then
			dynamicDiff.diffTorqueSplitA = dynamicDiff.diffTorqueSplitA + stepping
			dynamicDiff.diffTorqueSplitB = dynamicDiff.diffTorqueSplitB - stepping
		else
			dynamicDiff.diffTorqueSplitA = 1 - minSubOutput
			dynamicDiff.diffTorqueSplitB = minSubOutput
		end
	
		if dynamicDiff.diffTorqueSplitA < minMainOutput then
			dynamicDiff.diffTorqueSplitA = minMainOutput
			dynamicDiff.diffTorqueSplitB = 1 - minMainOutput
		end
	
		if dynamicDiff.diffTorqueSplitB < 0 then
			dynamicDiff.diffTorqueSplitA = 1 - minSubOutput
			dynamicDiff.diffTorqueSplitB = minSubOutput
		end
	elseif mainOutput == 2 then
		if abs(dynamicDiff.outputAV1 - dynamicDiff.outputAV2) * 9.549296596425384 >= maxrpmDifference and dynamicDiff.diffTorqueSplitB ~= minMainOutput then
			dynamicDiff.diffTorqueSplitB = dynamicDiff.diffTorqueSplitB - stepping
			dynamicDiff.diffTorqueSplitA = dynamicDiff.diffTorqueSplitA + stepping
		elseif dynamicDiff.diffTorqueSplitB ~= 1 - minSubOutput then
			dynamicDiff.diffTorqueSplitB = dynamicDiff.diffTorqueSplitB + stepping
			dynamicDiff.diffTorqueSplitA = dynamicDiff.diffTorqueSplitA - stepping
		else
			dynamicDiff.diffTorqueSplitB = 1 - minSubOutput
			dynamicDiff.diffTorqueSplitA = minSubOutput
		end
	
		if dynamicDiff.diffTorqueSplitB < minMainOutput then
			dynamicDiff.diffTorqueSplitB = minMainOutput
			dynamicDiff.diffTorqueSplitA = 1 - minMainOutput
		end
	
		if dynamicDiff.diffTorqueSplitA < 0 then
			dynamicDiff.diffTorqueSplitB = 1 - minSubOutput
			dynamicDiff.diffTorqueSplitA = minSubOutput
		end
	end

	
end

local function reset()
	if mainOutput == 1 then
		dynamicDiff.diffTorqueSplitA = 1 - minSubOutput
		dynamicDiff.diffTorqueSplitB = minSubOutput
	elseif mainOutput == 2 then
		dynamicDiff.diffTorqueSplitA = minSubOutput
		dynamicDiff.diffTorqueSplitB = 1 - minSubOutput
	end
end

local function init(jbeamData)
	local diffName = jbeamData.diffName
	dynamicDiff = powertrain.getDevice(diffName)
	
	mainOutput = jbeamData.mainOutput or 1
	minMainOutput = jbeamData.minMainOutput or 0.50
	minSubOutput = jbeamData.minSubOutput or 0.00
	if minMainOutput + minSubOutput > 1 then
		minSubOutput = 0.00
	end
	maxrpmDifference = jbeamData.maxrpmDifference or 50
	stepping = jbeamData.stepping or 0.01

	if mainOutput == 1 then
		dynamicDiff.diffTorqueSplitA = 1 - minSubOutput
		dynamicDiff.diffTorqueSplitB = minSubOutput
	elseif mainOutput == 2 then
		dynamicDiff.diffTorqueSplitA = minSubOutput
		dynamicDiff.diffTorqueSplitB = 1 - minSubOutput
	end
end

M.init = init
M.reset = reset
M.updateGFX = updateGFX

return M